signed

QiShunwang

“诚信为本、客户至上”

httpclient.jar与系统包冲突 java.lang.NoSuchFieldError: No static field INSTANCE of type Lorg/apache/http/c

2020/8/20 14:20:43   来源:

最近接到项目需求,在APP内,用户的数据如有更新,需要给用户推送短信通知用户,本人虽然做过Android很多年,但是短信推送还是第一次做,先了解一下感觉用第三方平台是个不错的选择,于是动手写起来。

但是后面发现需要用到

HttpClient这个类,

于是搜索下载,找到一个免费版的

httpclient-4.5.jar

于是兴致勃勃的添加到项目里,一路都很顺利。

但是到运行时发现闪退,一看log才发现报这个糟心的错:

java.lang.NoSuchFieldError: No static field INSTANCE of type Lorg/apache/http/conn/ssl/AllowAllHostnameVerifier; in class Lorg/apache/http/conn/ssl/AllowAllHostnameVerifier; or its superclasses (declaration of 'org.apache.http.conn.ssl.AllowAllHostnameVerifier' appears in /system/framework/framework.jar!classes3.dex)

仔细读,才知道是这个引用的jar包与系统framework下面的jar包用到了同样的类名,导致冲突了,怎么办?既不能修改自己引用的的jar包,也不能修改系统的jar包,两边都不能动,只能自己想办法,于是网上各种搜索,各路大神也给出了好多种解决办法:

1.

把依赖中的

implementation files('libs/httpclient-4.5.jar')

替换成下面的

implementation group: 'org.apache.httpcomponents' , name: 'httpclient' , version: '4.5'

2.在app build.gradle中添加

android  {
    ...

    useLibrary 'org.apache.http.legacy'
}

··· ···

但是到我这儿都不适用,真想哭啊,好在天无绝人之路,最后的最后看到说是httpclient-4.5.jar这个jar包太新了,有旧版的不冲突,于是这种找,发现这个版本

httpclient-4.3.5.jar与httpcore-4.4.1.jar用起来不会与framework.jar冲突,历尽艰辛,终于解决了。

jar包资源下载请参考 https://download.csdn.net/download/liqin19870815/12732762